searchData={"items":[{"type":"task","title":"mix serum","doc":"Prints a list of available Serum tasks.\n\n    mix serum\n\nThis task does not take any command line argument.","ref":"Mix.Tasks.Serum.html"},{"type":"task","title":"mix serum.build","doc":"Builds the Serum project at the specified directory.\n\n    mix serum.build [(-o|--output) PATH]\n\nThe website will be built into `PATH` if `-o(--output) PATH` option is given,\notherwise `/path/to/project/site` directory.\n\nIf the output directory exists and is not empty, all files and directories\nunder that directory will be deleted before the build process begins.\nHowever, any files or directories which names start with a dot (`.`) are\npreserved, as they may contain important information such as version\ncontrol-related data.","ref":"Mix.Tasks.Serum.Build.html"},{"type":"task","title":"Options - mix serum.build","doc":"- `-o(--output)` (string): Specifies the output directory. Defaults to\n  `/path/to/project/site`.","ref":"Mix.Tasks.Serum.Build.html#module-options"},{"type":"task","title":"mix serum.gen.page","doc":"Adds a new page to the current project.\n\n    mix serum.gen.page (-t|--title) TITLE (-o|--output) OUTPUT [Options]","ref":"Mix.Tasks.Serum.Gen.Page.html"},{"type":"task","title":"Required Options - mix serum.gen.page","doc":"- `-t(--title)` (string): Title of the new page.\n- `-o(--output)` (string): The path where the new page will be saved,\n  relative to `pages/` directory. It must end with one of `.md`, `.html`,\n  or `.html.eex`.","ref":"Mix.Tasks.Serum.Gen.Page.html#module-required-options"},{"type":"task","title":"Other Options - mix serum.gen.page","doc":"- `-l(--label)` (string): Label of the new page. Defaults to the page title.\n- `-g(--group)` (string): Name of a group the new page belongs to.\n- `-r(--order)` (integer): The order of the new page in a group.\n  Defaults to `0`.","ref":"Mix.Tasks.Serum.Gen.Page.html#module-other-options"},{"type":"task","title":"mix serum.gen.post","doc":"Adds a new blog post to the current project.\n\n    mix serum.gen.post (-t|--title) TITLE (-o|--output) OUTPUT [Options]\n\nPost date will be automatically set to the moment this task is executed.","ref":"Mix.Tasks.Serum.Gen.Post.html"},{"type":"task","title":"Required Options - mix serum.gen.post","doc":"- `-t(--title)` (string): Title of the new blog post.\n- `-o(--output)` (string): Name of the generated post file. The actual path\n  to the generated file will be in the form of\n  `posts/YYYY-MM-DD- .md`.","ref":"Mix.Tasks.Serum.Gen.Post.html#module-required-options"},{"type":"task","title":"Other Options - mix serum.gen.post","doc":"- `-g(--tag)` (string): Tag(s) of the new post. You can provide this option\n  zero or more times to give multiple tags to the post.","ref":"Mix.Tasks.Serum.Gen.Post.html#module-other-options"},{"type":"task","title":"mix serum.server","doc":"Starts the Serum development server.\n\n    mix serum.server [(-p|--port) PORT]\n\nThis task builds the current Serum project at a temporary directory, and\nstarts the development server. The server uses the port `8080` by default.","ref":"Mix.Tasks.Serum.Server.html"},{"type":"task","title":"Options - mix serum.server","doc":"- `-p(--port)` (integer): Use a specific port instead of `8080`. This is\n  useful when the default port is not available for use.","ref":"Mix.Tasks.Serum.Server.html#module-options"},{"type":"module","title":"Serum.Md.Parser","doc":"","ref":"Serum.Md.Parser.html"},{"type":"function","title":"Serum.Md.Parser.listener/2","doc":"","ref":"Serum.Md.Parser.html#listener/2"},{"type":"function","title":"Serum.Md.Parser.syntax/0","doc":"","ref":"Serum.Md.Parser.html#syntax/0"},{"type":"module","title":"Serum","doc":"Defines Serum OTP application.\n\nSerum is a simple static website generator written in Elixir programming\nlanguage. The goal of this project is to provide the way to create awesome\nstatic websites with little effort.\n\nThis documentation is for developers and advanced users. For the getting\nstarted guide and the user manual, please visit [the official Serum\nwebsite](https://dalgona.github.io/Serum).\n\nAlso, documentations for modules related to the internal operation of Serum\nare hidden. But such modules are still documented in [their source\ncodes](https://github.com/Dalgona/Serum).","ref":"Serum.html"},{"type":"function","title":"Serum.start/2","doc":"Starts the `:serum_md` application.\n\nThis starts a supervisor process which manages some children maintaining\nstates or data required for execution of Serum.","ref":"Serum.html#start/2"},{"type":"module","title":"Serum.Build","doc":"A module for managing the overall project build procedure.","ref":"Serum.Build.html"},{"type":"function","title":"Serum.Build.build/1","doc":"Builds the given Serum project.","ref":"Serum.Build.html#build/1"},{"type":"function","title":"Build Procedure - Serum.Build.build/1","doc":"1. Tries to load plugins and a theme.\n\n2. Checks if the system timezone is properly set.\n\n    Timex requires the local timezone information to format the date/time\n    string. If it's not set or invalid, Timex will fail.\n\n3. Checks if the current user has enough permission on the destination\n  directory and cleans it if it already exists.\n\n4. Loads source files. See `Serum.Build.FileLoader`.\n\n5. Processes source files and produces intermediate data structures.\n  See `Serum.Build.FileProcessor`.\n\n6. Generates HTML fragments from the intermediate data.\n  See `Serum.Build.FragmentGenerator`.\n\n7. Renders full HTML pages from fragments and writes them to files.\n  See `Serum.Build.FileEmitter`.\n\n8. Copies `assets/` and `media/` directories if they exist.","ref":"Serum.Build.html#build/1-build-procedure"},{"type":"module","title":"Serum.DevServer","doc":"The Serum development server.","ref":"Serum.DevServer.html"},{"type":"function","title":"Serum.DevServer.run/2","doc":"Starts the Serum development server.\n\nThis function returns `{:ok, pid}` on success where `pid` is a process ID of\na supervision tree for the Serum development server.","ref":"Serum.DevServer.html#run/2"},{"type":"module","title":"Serum.DevServer.Prompt","doc":"Provides access to the Serum development server command line interface.","ref":"Serum.DevServer.Prompt.html"},{"type":"function","title":"Serum.DevServer.Prompt.start/1","doc":"Tries to start a Serum development server command line interface.\n\nThis function first checks if the server is already running. If the server\nis not running, this function returns `{:error, :noproc}` immediately.\nOtherwise, it starts a loop which processes commands from the user. If the\nuser runs the `detach` command, the loop completes and this function returns\n`{:ok, :detached}` tuple. If the user runs the `quit` command, the Serum\ndevelopment server will be stopped, and then this function will return\n`{:ok, :quitted}` tuple.","ref":"Serum.DevServer.Prompt.html#start/1"},{"type":"function","title":"Options - Serum.DevServer.Prompt.start/1","doc":"- `allow_detach`: Controls if users are allowed to detach the command line\n  interface. Defaults to `true`.","ref":"Serum.DevServer.Prompt.html#start/1-options"},{"type":"type","title":"Serum.DevServer.Prompt.options/0","doc":"","ref":"Serum.DevServer.Prompt.html#t:options/0"},{"type":"type","title":"Serum.DevServer.Prompt.result/0","doc":"","ref":"Serum.DevServer.Prompt.html#t:result/0"},{"type":"module","title":"Serum.File","doc":"Defines a struct representing a file to be read or written.","ref":"Serum.File.html"},{"type":"module","title":"Fields - Serum.File","doc":"* `src`: Source path\n* `dest`: Destination path\n* `in_data`: Data read from a file\n* `out_data`: Data to be written to a file","ref":"Serum.File.html#module-fields"},{"type":"function","title":"Serum.File.read/1","doc":"Reads data from a file described by the given `Serum.File` struct.\n\nAn error will be returned if `src` is `nil`.","ref":"Serum.File.html#read/1"},{"type":"function","title":"Serum.File.write/1","doc":"Writes data to a file described by the given `Serum.File` struct.\n\nAn error will be returned if `dest` is `nil`.","ref":"Serum.File.html#write/1"},{"type":"type","title":"Serum.File.t/0","doc":"","ref":"Serum.File.html#t:t/0"},{"type":"module","title":"Serum.Fragment","doc":"Defines a struct representing a page fragment.","ref":"Serum.Fragment.html"},{"type":"module","title":"Fields - Serum.Fragment","doc":"* `file`: Source path. This can be `nil` if created internally.\n* `output`: Destination path\n* `metadata`: A map holding extra information about the fragment\n* `data`: Contents of the page fragment","ref":"Serum.Fragment.html#module-fields"},{"type":"function","title":"Serum.Fragment.new/4","doc":"Creates a new `Fragment` struct.","ref":"Serum.Fragment.html#new/4"},{"type":"type","title":"Serum.Fragment.t/0","doc":"","ref":"Serum.Fragment.html#t:t/0"},{"type":"module","title":"Serum.Page","doc":"Defines a struct describing a normal page.","ref":"Serum.Page.html"},{"type":"module","title":"Fields - Serum.Page","doc":"* `file`: Source path\n* `type`: Type of source file\n* `title`: Page title\n* `label`: Page label\n* `group`: A group the page belongs to\n* `order`: Order of the page within its group\n* `url`: Absolute URL of the page within the website\n* `output`: Destination path\n* `data`: Source data","ref":"Serum.Page.html#module-fields"},{"type":"function","title":"Serum.Page.compact/1","doc":"","ref":"Serum.Page.html#compact/1"},{"type":"function","title":"Serum.Page.new/4","doc":"","ref":"Serum.Page.html#new/4"},{"type":"function","title":"Serum.Page.to_fragment/1","doc":"","ref":"Serum.Page.html#to_fragment/1"},{"type":"type","title":"Serum.Page.t/0","doc":"","ref":"Serum.Page.html#t:t/0"},{"type":"module","title":"Serum.Post","doc":"Defines a struct representing a blog post page.","ref":"Serum.Post.html"},{"type":"module","title":"Fields - Serum.Post","doc":"* `file`: Source path\n* `title`: Post title\n* `date`: Post date (formatted)\n* `raw_date`: Post date (erlang tuple style)\n* `tags`: A list of tags\n* `url`: Absolute URL of the blog post in the website\n* `canonical_url`: Custom canonical URL of the blog post\n* `html`: Post contents converted into HTML\n* `preview`: Preview text of the post\n* `output`: Destination path","ref":"Serum.Post.html#module-fields"},{"type":"function","title":"Serum.Post.compact/1","doc":"","ref":"Serum.Post.html#compact/1"},{"type":"function","title":"Serum.Post.new/4","doc":"","ref":"Serum.Post.html#new/4"},{"type":"function","title":"Serum.Post.to_fragment/1","doc":"","ref":"Serum.Post.html#to_fragment/1"},{"type":"type","title":"Serum.Post.t/0","doc":"","ref":"Serum.Post.html#t:t/0"},{"type":"module","title":"Serum.PostList","doc":"Defines a struct representing a list of blog posts.","ref":"Serum.PostList.html"},{"type":"module","title":"Fields - Serum.PostList","doc":"* `tag`: Specifies by which tag the posts are filtered. Can be `nil`\n* `current_page`: Number of current page\n* `max_page`: Number of the last page\n* `title`: Title of the list\n* `posts`: A list of `Post` structs\n* `url`: Absolute URL of this list page in the website\n* `prev_url`: Absolute URL of the previous list page. Can be `nil` if this is\n  the first page\n* `next_url`: Absolute URL of the next list page. Can be `nil` if this is\n  the last page\n* `output`: Destination path","ref":"Serum.PostList.html#module-fields"},{"type":"function","title":"Serum.PostList.compact/1","doc":"","ref":"Serum.PostList.html#compact/1"},{"type":"function","title":"Serum.PostList.generate/3","doc":"","ref":"Serum.PostList.html#generate/3"},{"type":"function","title":"Serum.PostList.to_fragment/1","doc":"","ref":"Serum.PostList.html#to_fragment/1"},{"type":"type","title":"Serum.PostList.maybe_tag/0","doc":"","ref":"Serum.PostList.html#t:maybe_tag/0"},{"type":"type","title":"Serum.PostList.t/0","doc":"","ref":"Serum.PostList.html#t:t/0"},{"type":"module","title":"Serum.Project","doc":"This module defines a struct for storing Serum project metadata.","ref":"Serum.Project.html"},{"type":"function","title":"Serum.Project.default_date_format/0","doc":"","ref":"Serum.Project.html#default_date_format/0"},{"type":"function","title":"Serum.Project.default_list_title_tag/0","doc":"","ref":"Serum.Project.html#default_list_title_tag/0"},{"type":"function","title":"Serum.Project.new/1","doc":"Creates a new Project struct using the given `map`.","ref":"Serum.Project.html#new/1"},{"type":"type","title":"Serum.Project.pretty_urls/0","doc":"Accepted value for the `pretty_urls` option\n\n- `false` disables pretty URLs.\n- `true` is currently the same as `:posts`.\n- `:posts` enables pretty URLs only for blog posts.","ref":"Serum.Project.html#t:pretty_urls/0"},{"type":"type","title":"Serum.Project.t/0","doc":"","ref":"Serum.Project.html#t:t/0"},{"type":"module","title":"Serum.Result","doc":"This module defines types for positive results or errors returned by\nfunctions in this project.","ref":"Serum.Result.html"},{"type":"function","title":"Serum.Result.aggregate/2","doc":"Takes a list of results without value and checks if there is no error.\n\nReturns `:ok` if there is no error.\n\nReturns an aggregated error object if there is one or more errors.","ref":"Serum.Result.html#aggregate/2"},{"type":"function","title":"Serum.Result.aggregate_values/2","doc":"Takes a list of results with values and checks if there is no error.\n\nIf there is no error, it returns `{:ok, list}` where `list` is a list of\nreturned values.\n\nReturns an aggregated error object if there is one or more errors.","ref":"Serum.Result.html#aggregate_values/2"},{"type":"function","title":"Serum.Result.get_message/2","doc":"Gets a human friendly message from the given `result`.\n\nYou can control the indentation level by passing a non-negative integer to\nthe `depth` parameter.","ref":"Serum.Result.html#get_message/2"},{"type":"function","title":"Serum.Result.show/2","doc":"Prints an error object in a beautiful format.","ref":"Serum.Result.html#show/2"},{"type":"type","title":"Serum.Result.err_details/0","doc":"","ref":"Serum.Result.html#t:err_details/0"},{"type":"type","title":"Serum.Result.error/0","doc":"","ref":"Serum.Result.html#t:error/0"},{"type":"type","title":"Serum.Result.full_detail/0","doc":"","ref":"Serum.Result.html#t:full_detail/0"},{"type":"type","title":"Serum.Result.msg_detail/0","doc":"","ref":"Serum.Result.html#t:msg_detail/0"},{"type":"type","title":"Serum.Result.nest_detail/0","doc":"","ref":"Serum.Result.html#t:nest_detail/0"},{"type":"type","title":"Serum.Result.t/0","doc":"","ref":"Serum.Result.html#t:t/0"},{"type":"type","title":"Serum.Result.t/1","doc":"","ref":"Serum.Result.html#t:t/1"},{"type":"module","title":"Serum.Tag","doc":"This module defines Tag struct.","ref":"Serum.Tag.html"},{"type":"function","title":"Serum.Tag.batch_create/2","doc":"","ref":"Serum.Tag.html#batch_create/2"},{"type":"function","title":"Serum.Tag.new/2","doc":"","ref":"Serum.Tag.html#new/2"},{"type":"type","title":"Serum.Tag.t/0","doc":"","ref":"Serum.Tag.html#t:t/0"},{"type":"module","title":"Serum.Template","doc":"Defines a struct which stores a template and its information.","ref":"Serum.Template.html"},{"type":"function","title":"Serum.Template.new/4","doc":"","ref":"Serum.Template.html#new/4"},{"type":"type","title":"Serum.Template.collection/0","doc":"","ref":"Serum.Template.html#t:collection/0"},{"type":"type","title":"Serum.Template.t/0","doc":"","ref":"Serum.Template.html#t:t/0"},{"type":"type","title":"Serum.Template.type/0","doc":"","ref":"Serum.Template.html#t:type/0"},{"type":"module","title":"Serum.Plugins.LiveReloader","doc":"A Serum plugin that injects the live reloader script at the end of HTML files.\n\nOnce the page is loaded inside your web browser, the injected script tries to\nconnect to the Serum development server via WebSocket. When the page receives\n\"reload\" message from the server, it refreshes the current page.\n\nIf you disable this plugin, you need to manually refresh the page after you\nmade some changes to your source files.","ref":"Serum.Plugins.LiveReloader.html"},{"type":"module","title":"Using the Plugin - Serum.Plugins.LiveReloader","doc":"You usually don't want the script injected into pages when the Serum\ndevelopment server is not running. Let the plugin run only when `Mix.env()`\nis `dev`, and run `MIX_ENV=prod mix serum.build` when you are about to\npublish your website.\n\n    # serum.exs:\n    %{\n      plugins: [\n        {Serum.Plugins.LiveReloader, only: :dev}\n      ]\n    }","ref":"Serum.Plugins.LiveReloader.html#module-using-the-plugin"},{"type":"function","title":"Serum.Plugins.LiveReloader.description/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#description/0"},{"type":"function","title":"Serum.Plugins.LiveReloader.elixir/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#elixir/0"},{"type":"function","title":"Serum.Plugins.LiveReloader.implements/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#implements/0"},{"type":"function","title":"Serum.Plugins.LiveReloader.name/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#name/0"},{"type":"function","title":"Serum.Plugins.LiveReloader.rendered_page/2","doc":"","ref":"Serum.Plugins.LiveReloader.html#rendered_page/2"},{"type":"function","title":"Serum.Plugins.LiveReloader.serum/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#serum/0"},{"type":"function","title":"Serum.Plugins.LiveReloader.version/0","doc":"","ref":"Serum.Plugins.LiveReloader.html#version/0"},{"type":"module","title":"Serum.Plugins.PreviewGenerator","doc":"A Serum plugin that generates preview texts of pages and blog posts.","ref":"Serum.Plugins.PreviewGenerator.html"},{"type":"module","title":"Using the Plugin - Serum.Plugins.PreviewGenerator","doc":"First, add this plugin to your `serum.exs`:\n\n    %{\n      plugins: [\n        # Use this plugin with default options.\n        Serum.Plugins.PreviewGenerator\n\n        # Or, use this plugin with custom options.\n        {Serum.Plugins.PreviewGenerator, args: options}\n      ]\n    }\n\nBy default, this plugin takes the text of the first paragraph (` ` tag) to\ngenerate the preview text for each page or blog post. This behavior can be\ncustomized; see the \"Configuration\" section below for a list of available\noptions.\n\nGenerated preview texts will be saved in `:extras` map of each page or post,\nwith `\"preview\"` key. The name of key can also be customized.\n\n    <%= for post <- @all_posts do %>\n       \n        <!-- ... -->\n         <%= post.extras[\"preview\"] \n       \n    <% end %>\n\nIf a page or a blog post already has `extras[\"preview\"]` (or other key\nspecified by the `:preview_key` option), its value will be used instead.\n\n    ---\n    title: Sample Blog Post\n    date: 2020-07-17\n    tags: sample\n    preview: This string will be used instead as a preview text of this post.\n    ---\n\n    Lorem ipsum dolor sit amet, ...","ref":"Serum.Plugins.PreviewGenerator.html#module-using-the-plugin"},{"type":"module","title":"Configuration - Serum.Plugins.PreviewGenerator","doc":"- `:length`\n\n  A keyword list which determines the maximum length of each preview text.\n  Each item of this keyword list is called a \"length spec,\" and a length\n  spec should look like one of the following:\n\n  - `{:chars, max_chars}` - Limits the maximum length of preview texts to\n    `max_chars` characters.\n\n  - `{:words, max_words}` - Limits the maximum length of preview texts to\n    `max_words` words. Each word is a group of characters split by one\n    or more whitespace characters.\n\n  - `{:paragraphs, max_paragraphs}` - Limits the maximum length of preview\n    texts to `max_paragraphs` paragraphs. This option assumes that contents\n    of each page or blog post is well organized using ` ` tags. Otherwise\n    this plugin may produce undesired results.\n\n  This keyword list can have more than one length specs. In that case, this\n  plugin will \"sample\" multiple preview texts for each page or blog post,\n  and it will pick the shortest one as a final preview text.\n\n  Defaults to `[paragraphs: 1]`.\n\n- `:preview_key`\n\n  A string which will be used as an alternative key for storing generated\n  preview texts. For example, if you set `:preview_key` to `\"summary\"`, you\n  will be able to access the preview text in your templates like this:\n\n      <% %Serum.Post{} = post %>\n       <%= post.extras[\"summary\"] %> \n\n  Defaults to `\"preview\"`. If any value is given, any leading or trailing\n  whitespaces will be trimmed.\n\n#","ref":"Serum.Plugins.PreviewGenerator.html#module-configuration"},{"type":"module","title":"Configuration Example - Serum.Plugins.PreviewGenerator","doc":"# In your serum.exs:\n    %{\n      plugins: [\n        {Serum.Plugins.PreviewGenerator,\n         args: [\n           length: [paragraphs: 1, chars: 250],\n           preview_key: \"preview_text\"\n         ]}\n      ]\n    }","ref":"Serum.Plugins.PreviewGenerator.html#module-configuration-example"},{"type":"module","title":"Serum.Plugins.RssGenerator","doc":"A Serum plugin that creates an RSS feed","ref":"Serum.Plugins.RssGenerator.html"},{"type":"module","title":"Using the Plugin - Serum.Plugins.RssGenerator","doc":"# serum.exs:\n    %{\n      server_root: \"https://example.io\",\n      plugins: [\n        {Serum.Plugins.RssGenerator, only: :prod}\n      ]\n    }","ref":"Serum.Plugins.RssGenerator.html#module-using-the-plugin"},{"type":"function","title":"Serum.Plugins.RssGenerator.build_succeeded/3","doc":"","ref":"Serum.Plugins.RssGenerator.html#build_succeeded/3"},{"type":"function","title":"Serum.Plugins.RssGenerator.description/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#description/0"},{"type":"function","title":"Serum.Plugins.RssGenerator.elixir/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#elixir/0"},{"type":"function","title":"Serum.Plugins.RssGenerator.implements/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#implements/0"},{"type":"function","title":"Serum.Plugins.RssGenerator.name/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#name/0"},{"type":"function","title":"Serum.Plugins.RssGenerator.serum/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#serum/0"},{"type":"function","title":"Serum.Plugins.RssGenerator.version/0","doc":"","ref":"Serum.Plugins.RssGenerator.html#version/0"},{"type":"module","title":"Serum.Plugins.SitemapGenerator","doc":"A Serum plugin that create a sitemap so that the search engine can index posts.","ref":"Serum.Plugins.SitemapGenerator.html"},{"type":"module","title":"Using the Plugin - Serum.Plugins.SitemapGenerator","doc":"# serum.exs:\n    %{\n      server_root: \"https://example.io\",\n      plugins: [\n        {Serum.Plugins.SitemapGenerator, only: :prod}\n      ]\n    }","ref":"Serum.Plugins.SitemapGenerator.html#module-using-the-plugin"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.build_succeeded/3","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#build_succeeded/3"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.description/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#description/0"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.elixir/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#elixir/0"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.implements/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#implements/0"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.name/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#name/0"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.serum/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#serum/0"},{"type":"function","title":"Serum.Plugins.SitemapGenerator.version/0","doc":"","ref":"Serum.Plugins.SitemapGenerator.html#version/0"},{"type":"module","title":"Serum.Plugins.TableOfContents","doc":"A Serum plugin that inserts a table of contents.","ref":"Serum.Plugins.TableOfContents.html"},{"type":"module","title":"Using the Plugin - Serum.Plugins.TableOfContents","doc":"First, add this plugin to your `serum.exs`:\n\n    %{\n      plugins: [\n        Serum.Plugins.TableOfContents\n      ]\n    }\n\nThis plugin works with both pages(`.md`, `.html`, and `.html.eex`) and blog\nposts(`.md`). Insert the ` ` tag at the position you want to\ndisplay a table of contents at.\n\n      \n\nThe `start` and `end` attributes define a range of heading level this plugin\nrecognizes. In the case of the above example, ` `, ` `, and ` ` tags\nare ignored when generating a table of contents.\n\nAfter this plugin has run, each ` ` tag is replaced with an\nunordered list:\n\n     \n       \n         \n           1 \n          Section 1\n         \n       \n      <!-- More list items here... -->\n     \n\nThis plugin produces a \"flat\" unordered list. However, each list item tag has\nan `indent-x` class, where `x` is an indentation level (from 0 to 5) of the\ncurrent item in the list. You can utilize this when working on stylesheets.\n\nThe `id` attribute of each target heading tag is used when hyperlinks are\ngenerated. If the element does not have an `id`, the plugin will set one\nappropriately.","ref":"Serum.Plugins.TableOfContents.html#module-using-the-plugin"},{"type":"module","title":"Notes - Serum.Plugins.TableOfContents","doc":"You may use ` ` tag more than once in a single page. However, all\noccurrences of this tag will be replaced with a table of contents generated\nusing the attributes of the first one. That is, for example, all three tags\nin the code below expand to the same table of contents, showing a 2-level\ndeep list.\n\n      \n    ...\n      \n    ...\n      \n\nIt's recommended that you wrap a ` ` tag with a ` ` tag when\nusing in a markdown file, to ensure a well-formed structure of HTML output.\n\n        \n\nAnd finally, make sure you close every ` ` tag properly\nwith ` `.","ref":"Serum.Plugins.TableOfContents.html#module-notes"},{"type":"function","title":"Serum.Plugins.TableOfContents.description/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#description/0"},{"type":"function","title":"Serum.Plugins.TableOfContents.elixir/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#elixir/0"},{"type":"function","title":"Serum.Plugins.TableOfContents.implements/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#implements/0"},{"type":"function","title":"Serum.Plugins.TableOfContents.name/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#name/0"},{"type":"function","title":"Serum.Plugins.TableOfContents.rendering_fragment/3","doc":"","ref":"Serum.Plugins.TableOfContents.html#rendering_fragment/3"},{"type":"function","title":"Serum.Plugins.TableOfContents.serum/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#serum/0"},{"type":"function","title":"Serum.Plugins.TableOfContents.version/0","doc":"","ref":"Serum.Plugins.TableOfContents.html#version/0"},{"type":"behaviour","title":"Serum.Plugin","doc":"A behaviour that all Serum plugin module must implement.\n\nThis module allows experienced Serum users and developers to make their own\nSerum plugins which can extend the functionality of Serum.\n\nA Serum plugin can...\n\n- Alter contents of input or output files,\n- Execute arbitrary codes during some stages of site building,\n- And optionally provide extra Mix tasks that extends Serum.","ref":"Serum.Plugin.html"},{"type":"behaviour","title":"For Plugin Developers - Serum.Plugin","doc":"In order for a Serum plugin to work, you must implement at least these\nfour callbacks:\n\n- `name/0`\n- `version/0`\n- `elixir/0`\n- `serum/0`\n- `description/0`\n- `implements/0`\n\nAlso there are a number of other callbacks you can optionally implement.\nRead the rest of the documentation for this module to see which callbacks\nyou can implement and what each callback should do.","ref":"Serum.Plugin.html#module-for-plugin-developers"},{"type":"behaviour","title":"For Plugin Users - Serum.Plugin","doc":"To enable Serum plugins, add a `plugins` key to your `serum.exs`(if it does\nnot exist), and put names of Serum plugin modules there.\n\n    %{\n      plugins: [\n        Awesome.Serum.Plugin,\n        Great.Serum.Plugin\n      ]\n    }\n\nYou can also restrict some plugins to run only in specific Mix environments.\nFor example, if plugins are configured like the code below, only\n`Awesome.Serum.Plugin` plugin will be loaded when `MIX_ENV` is set to `prod`.\n\n    %{\n      plugins: [\n        Awesome.Serum.Plugin,\n        {Great.Serum.Plugin, only: :dev},\n        {Another.Serum.Plugin, only: [:dev, :test]}\n      ]\n    }\n\nThe order of plugins is important, as Serum will call plugins one by one,\nfrom the first item to the last one. Therefore these two configurations below\nmay produce different results.\n\nConfiguration 1:\n\n    %{\n      plugins: [\n        Awesome.Serum.Plugin,\n        Another.Serum.Plugin\n      ]\n    }\n\nConfiguration 2:\n\n    %{\n      plugins: [\n        Another.Serum.Plugin,\n        Awesome.Serum.Plugin\n      ]\n    }","ref":"Serum.Plugin.html#module-for-plugin-users"},{"type":"function","title":"Serum.Plugin.build_failed/3","doc":"","ref":"Serum.Plugin.html#build_failed/3"},{"type":"callback","title":"Serum.Plugin.build_failed/3","doc":"Called if the build process has failed for some reason.","ref":"Serum.Plugin.html#c:build_failed/3"},{"type":"callback","title":"Serum.Plugin.build_failed/4","doc":"","ref":"Serum.Plugin.html#c:build_failed/4"},{"type":"function","title":"Serum.Plugin.build_started/2","doc":"","ref":"Serum.Plugin.html#build_started/2"},{"type":"callback","title":"Serum.Plugin.build_started/2","doc":"Called right after the build process has started. Some necessary OTP\napplications or processes should be started here.","ref":"Serum.Plugin.html#c:build_started/2"},{"type":"callback","title":"Serum.Plugin.build_started/3","doc":"","ref":"Serum.Plugin.html#c:build_started/3"},{"type":"function","title":"Serum.Plugin.build_succeeded/2","doc":"","ref":"Serum.Plugin.html#build_succeeded/2"},{"type":"callback","title":"Serum.Plugin.build_succeeded/2","doc":"Called if the whole build process has finished successfully.","ref":"Serum.Plugin.html#c:build_succeeded/2"},{"type":"callback","title":"Serum.Plugin.build_succeeded/3","doc":"","ref":"Serum.Plugin.html#c:build_succeeded/3"},{"type":"function","title":"Serum.Plugin.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Serum.Plugin.html#child_spec/1"},{"type":"callback","title":"Serum.Plugin.description/0","doc":"Returns the short description of the plugin.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:description/0"},{"type":"callback","title":"Serum.Plugin.elixir/0","doc":"Returns the version requirement of Elixir.\n\nRefer to [this document](https://hexdocs.pm/elixir/Version.html#module-requirements)\nfor the string format.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:elixir/0"},{"type":"function","title":"Serum.Plugin.finalizing/2","doc":"","ref":"Serum.Plugin.html#finalizing/2"},{"type":"callback","title":"Serum.Plugin.finalizing/2","doc":"Called right before Serum exits, whether the build has succeeded or not.\n\nThis is the place where you should clean up any temporary resources created\nin `build_started/2` callback.","ref":"Serum.Plugin.html#c:finalizing/2"},{"type":"callback","title":"Serum.Plugin.finalizing/3","doc":"","ref":"Serum.Plugin.html#c:finalizing/3"},{"type":"callback","title":"Serum.Plugin.implements/0","doc":"Returns a list of optional callbacks which the plugin implements.\n\nEach list item can be in one of two forms:\n\n- `{callback_name, arity}`\n- `callback_name` - This is deprecated and left for compatibility. New Serum\n  plugins must use the above format.\n\nFor example, if your plugin implements `build_started/2` and `finalizing/2`,\nyou must implement this callback so that it returns `[build_started: 2,\nfinalizing: 2]`.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:implements/0"},{"type":"callback","title":"Serum.Plugin.name/0","doc":"Returns the name of the plugin.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:name/0"},{"type":"function","title":"Serum.Plugin.processed_list/1","doc":"","ref":"Serum.Plugin.html#processed_list/1"},{"type":"callback","title":"Serum.Plugin.processed_list/1","doc":"Called after Serum has processed each input file and produced\nthe resulting struct.\n\nPlugins can alter the processed contents and metadata here.","ref":"Serum.Plugin.html#c:processed_list/1"},{"type":"callback","title":"Serum.Plugin.processed_list/2","doc":"","ref":"Serum.Plugin.html#c:processed_list/2"},{"type":"function","title":"Serum.Plugin.processed_page/1","doc":"","ref":"Serum.Plugin.html#processed_page/1"},{"type":"callback","title":"Serum.Plugin.processed_page/1","doc":"Called after Serum has processed each input file and produced\nthe resulting struct.\n\nPlugins can alter the processed contents and metadata here.","ref":"Serum.Plugin.html#c:processed_page/1"},{"type":"callback","title":"Serum.Plugin.processed_page/2","doc":"","ref":"Serum.Plugin.html#c:processed_page/2"},{"type":"function","title":"Serum.Plugin.processed_pages/1","doc":"","ref":"Serum.Plugin.html#processed_pages/1"},{"type":"callback","title":"Serum.Plugin.processed_pages/1","doc":"Called after Serum has successfully processed all pages.","ref":"Serum.Plugin.html#c:processed_pages/1"},{"type":"callback","title":"Serum.Plugin.processed_pages/2","doc":"","ref":"Serum.Plugin.html#c:processed_pages/2"},{"type":"function","title":"Serum.Plugin.processed_post/1","doc":"","ref":"Serum.Plugin.html#processed_post/1"},{"type":"callback","title":"Serum.Plugin.processed_post/1","doc":"Called after Serum has processed each input file and produced\nthe resulting struct.\n\nPlugins can alter the processed contents and metadata here.","ref":"Serum.Plugin.html#c:processed_post/1"},{"type":"callback","title":"Serum.Plugin.processed_post/2","doc":"","ref":"Serum.Plugin.html#c:processed_post/2"},{"type":"function","title":"Serum.Plugin.processed_posts/1","doc":"","ref":"Serum.Plugin.html#processed_posts/1"},{"type":"callback","title":"Serum.Plugin.processed_posts/1","doc":"Called after Serum has successfully processed all blog posts.","ref":"Serum.Plugin.html#c:processed_posts/1"},{"type":"callback","title":"Serum.Plugin.processed_posts/2","doc":"","ref":"Serum.Plugin.html#c:processed_posts/2"},{"type":"function","title":"Serum.Plugin.processed_template/1","doc":"","ref":"Serum.Plugin.html#processed_template/1"},{"type":"callback","title":"Serum.Plugin.processed_template/1","doc":"Called after Serum has processed each input file and produced\nthe resulting struct.\n\nPlugins can alter the AST and its metadata here.","ref":"Serum.Plugin.html#c:processed_template/1"},{"type":"callback","title":"Serum.Plugin.processed_template/2","doc":"","ref":"Serum.Plugin.html#c:processed_template/2"},{"type":"function","title":"Serum.Plugin.processing_page/1","doc":"","ref":"Serum.Plugin.html#processing_page/1"},{"type":"callback","title":"Serum.Plugin.processing_page/1","doc":"Called before Serum processes each input file.\n\nPlugins can alter the raw contents of input files here.","ref":"Serum.Plugin.html#c:processing_page/1"},{"type":"callback","title":"Serum.Plugin.processing_page/2","doc":"","ref":"Serum.Plugin.html#c:processing_page/2"},{"type":"function","title":"Serum.Plugin.processing_post/1","doc":"","ref":"Serum.Plugin.html#processing_post/1"},{"type":"callback","title":"Serum.Plugin.processing_post/1","doc":"Called before Serum processes each input file.\n\nPlugins can alter the raw contents of input files here.","ref":"Serum.Plugin.html#c:processing_post/1"},{"type":"callback","title":"Serum.Plugin.processing_post/2","doc":"","ref":"Serum.Plugin.html#c:processing_post/2"},{"type":"function","title":"Serum.Plugin.processing_template/1","doc":"","ref":"Serum.Plugin.html#processing_template/1"},{"type":"callback","title":"Serum.Plugin.processing_template/1","doc":"Called before Serum processes each input file.\n\nPlugins can alter the raw contents of input files here.","ref":"Serum.Plugin.html#c:processing_template/1"},{"type":"callback","title":"Serum.Plugin.processing_template/2","doc":"","ref":"Serum.Plugin.html#c:processing_template/2"},{"type":"function","title":"Serum.Plugin.reading_pages/1","doc":"","ref":"Serum.Plugin.html#reading_pages/1"},{"type":"callback","title":"Serum.Plugin.reading_pages/1","doc":"Called before reading input files.\n\nPlugins can manipulate the list of files to be read and pass it to\nthe next plugin.","ref":"Serum.Plugin.html#c:reading_pages/1"},{"type":"callback","title":"Serum.Plugin.reading_pages/2","doc":"","ref":"Serum.Plugin.html#c:reading_pages/2"},{"type":"function","title":"Serum.Plugin.reading_posts/1","doc":"","ref":"Serum.Plugin.html#reading_posts/1"},{"type":"callback","title":"Serum.Plugin.reading_posts/1","doc":"Called before reading input files.\n\nPlugins can manipulate the list of files to be read and pass it to\nthe next plugin.","ref":"Serum.Plugin.html#c:reading_posts/1"},{"type":"callback","title":"Serum.Plugin.reading_posts/2","doc":"","ref":"Serum.Plugin.html#c:reading_posts/2"},{"type":"function","title":"Serum.Plugin.reading_templates/1","doc":"","ref":"Serum.Plugin.html#reading_templates/1"},{"type":"callback","title":"Serum.Plugin.reading_templates/1","doc":"Called before reading input files.\n\nPlugins can manipulate the list of files to be read and pass it to\nthe next plugin.","ref":"Serum.Plugin.html#c:reading_templates/1"},{"type":"callback","title":"Serum.Plugin.reading_templates/2","doc":"","ref":"Serum.Plugin.html#c:reading_templates/2"},{"type":"function","title":"Serum.Plugin.rendered_fragment/1","doc":"","ref":"Serum.Plugin.html#rendered_fragment/1"},{"type":"callback","title":"Serum.Plugin.rendered_fragment/1","doc":"Called after producing a HTML fragment for each page.\n\nPlugins can modify the contents and metadata of each fragment here.","ref":"Serum.Plugin.html#c:rendered_fragment/1"},{"type":"callback","title":"Serum.Plugin.rendered_fragment/2","doc":"","ref":"Serum.Plugin.html#c:rendered_fragment/2"},{"type":"function","title":"Serum.Plugin.rendered_page/1","doc":"","ref":"Serum.Plugin.html#rendered_page/1"},{"type":"callback","title":"Serum.Plugin.rendered_page/1","doc":"Called when Serum has rendered a full page and it's about to write to an\noutput file.\n\nPlugins can alter the raw contents of the page to be written.","ref":"Serum.Plugin.html#c:rendered_page/1"},{"type":"callback","title":"Serum.Plugin.rendered_page/2","doc":"","ref":"Serum.Plugin.html#c:rendered_page/2"},{"type":"function","title":"Serum.Plugin.rendering_fragment/2","doc":"","ref":"Serum.Plugin.html#rendering_fragment/2"},{"type":"callback","title":"Serum.Plugin.rendering_fragment/2","doc":"Called while each fragment is being constructed.\n\nPlugins can alter the HTML tree of its contents (which is generated by\nFloki). It is recommended to implement this callback if you want to modify\nthe HTML document without worrying about breaking it.","ref":"Serum.Plugin.html#c:rendering_fragment/2"},{"type":"callback","title":"Serum.Plugin.rendering_fragment/3","doc":"","ref":"Serum.Plugin.html#c:rendering_fragment/3"},{"type":"callback","title":"Serum.Plugin.serum/0","doc":"Returns the version requirement of Serum.\n\nRefer to [this document](https://hexdocs.pm/elixir/Version.html#module-requirements)\nfor the string format.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:serum/0"},{"type":"callback","title":"Serum.Plugin.version/0","doc":"Returns the version of the plugin.\n\nThe returned version string must follow the semantic versioning scheme.\n\nYou must implement this callback, or the plugin may fail.","ref":"Serum.Plugin.html#c:version/0"},{"type":"function","title":"Serum.Plugin.wrote_file/1","doc":"","ref":"Serum.Plugin.html#wrote_file/1"},{"type":"callback","title":"Serum.Plugin.wrote_file/1","doc":"Called after writing each output to a file.","ref":"Serum.Plugin.html#c:wrote_file/1"},{"type":"callback","title":"Serum.Plugin.wrote_file/2","doc":"","ref":"Serum.Plugin.html#c:wrote_file/2"},{"type":"type","title":"Serum.Plugin.plugin_options/0","doc":"","ref":"Serum.Plugin.html#t:plugin_options/0"},{"type":"type","title":"Serum.Plugin.spec/0","doc":"","ref":"Serum.Plugin.html#t:spec/0"},{"type":"type","title":"Serum.Plugin.t/0","doc":"","ref":"Serum.Plugin.html#t:t/0"},{"type":"behaviour","title":"Serum.Theme","doc":"A behaviour that all Serum theme module must implement.\n\nA Serum theme is a set of predefined templates and assets which are used\nwhile Serum is building a project.\n\nMore specifically, a Serum theme is a Mix project which has the following\ncontents:\n\n- Modules that implement this behaviour,\n- And theme files such as templates, includes, and other assets.\n  These files are usually stored in the `priv/` directory.\n\nYour theme package must have at least one module that implements this\nbehaviour, as Serum will call callbacks of this behaviour to ensure that your\nmodules provide appropriate theme resources when needed.","ref":"Serum.Theme.html"},{"type":"behaviour","title":"Using Serum Themes - Serum.Theme","doc":"To use a Serum theme, you first need to add the theme package to your\ndependencies list.\n\n    # mix.exs\n    defp deps do\n    [\n      {:serum_md, \"~> 1.0\"},\n      # ...\n\n      # If the theme is available on Hex.pm:\n      {:serum_theme_sample, \"~> 1.0\"}\n\n      # If the theme is available on somewhere else:\n      {:serum_theme_sample, git: \"https://github.com/...\"}\n    ]\n    end\n\nFetch and build the theme package using `mix`.\n\n    $ mix do deps.get, deps.compile\n\nTo configure your Serum project to use a theme, you need to put a `:theme`\nkey in your `serum.exs`.\n\n    # serum.exs:\n    %{\n      theme: Serum.Themes.Sample,\n      # ...\n    }\n\nRead the documentation provided by the theme author, to see the list of files\nthe theme consists of. Files provided by the theme are always overridden by\ncorresponding files in your project directory. So it is safe to remove files\nfrom your project if the theme has ones.\n\nFinally, try building your project to see if the theme is applied correctly.\n\n    $ mix serum.server\n    # Or,\n    $ MIX_ENV=prod mix serum.build","ref":"Serum.Theme.html#module-using-serum-themes"},{"type":"callback","title":"Serum.Theme.author/0","doc":"Returns information about the theme author.","ref":"Serum.Theme.html#c:author/0"},{"type":"function","title":"Serum.Theme.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Serum.Theme.html#child_spec/1"},{"type":"callback","title":"Serum.Theme.description/0","doc":"Returns a short descriptive text about the theme.","ref":"Serum.Theme.html#c:description/0"},{"type":"callback","title":"Serum.Theme.get_assets/0","doc":"Returns a path to the assets directory.\n\nAll files in the directory pointed by the returned value will be copied to\nthe destination assets directory using `File.cp_r/2`.\n\nThis callback may return `false` to indicate that no asset will be copied.","ref":"Serum.Theme.html#c:get_assets/0"},{"type":"callback","title":"Serum.Theme.get_includes/0","doc":"Returns a list of paths to include files.\n\nAll paths in the list must end with `\".html.eex\"`. Anything that does not end\nwith `\".html.eex\"` will be ignored.","ref":"Serum.Theme.html#c:get_includes/0"},{"type":"callback","title":"Example Return Value - Serum.Theme.get_includes/0","doc":"[\n      \"/path/to/theme/priv/includes/nav.html.eex\",\n      \"/path/to/theme/priv/includes/sidebar.html.eex\",\n      \"/path/to/theme/priv/includes/footer.html.eex\"\n    ]","ref":"Serum.Theme.html#c:get_includes/0-example-return-value"},{"type":"callback","title":"Serum.Theme.get_templates/0","doc":"Returns a list of paths to template files.\n\nAll paths in the list must end with `\".html.eex\"`. Anything that does not end\nwith `\".html.eex\"` will be ignored.","ref":"Serum.Theme.html#c:get_templates/0"},{"type":"callback","title":"Example Return Value - Serum.Theme.get_templates/0","doc":"[\n      \"/path/to/theme/priv/templates/base.html.eex\",\n      \"/path/to/theme/priv/templates/list.html.eex\",\n      \"/path/to/theme/priv/templates/post.html.eex\"\n    ]","ref":"Serum.Theme.html#c:get_templates/0-example-return-value"},{"type":"callback","title":"Serum.Theme.legal/0","doc":"Returns the legal information about the theme, such as license.","ref":"Serum.Theme.html#c:legal/0"},{"type":"callback","title":"Serum.Theme.name/0","doc":"Returns the theme name.","ref":"Serum.Theme.html#c:name/0"},{"type":"callback","title":"Serum.Theme.serum/0","doc":"Returns the required version of Serum.\n\nRead the \"Requirements\" section in the documentation for `Version` module\nfor more information about version requirement format.","ref":"Serum.Theme.html#c:serum/0"},{"type":"callback","title":"Serum.Theme.version/0","doc":"Returns the theme version.\n\nThe returned value must follow the semantic versioning scheme.","ref":"Serum.Theme.html#c:version/0"},{"type":"type","title":"Serum.Theme.t/0","doc":"","ref":"Serum.Theme.html#t:t/0"}],"content_type":"text/markdown"}